import { Datastore } from '../datastore/datastore';
export interface IObjectMetadata {
    id: string;
    created?: number;
    updated?: number;
}
export declare class Model<T extends Model<T>> {
    meta: IObjectMetadata;
    private store?;
    constructor(data?: {
        id: string;
        store: Datastore<T>;
    });
    save(): Promise<void>;
    delete(): Promise<void>;
}
