"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const class_transformer_1 = require("class-transformer");
const datastore_1 = require("../datastore/datastore");
class Model {
    constructor(data) {
        this.meta = { id: '_' };
        if (data != null) {
            this.meta = { id: data.id };
            this.store = data.store;
        }
    }
    save() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.store) {
                if (this.meta && this.meta.id) {
                    yield this.store.edit().item(this).with({}).run();
                }
                else {
                    yield this.store.push().item(this).run();
                }
            }
            else {
                throw Error('The model\'s store field is null. Use `datastore.create()` to create objects.');
            }
        });
    }
    delete() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.store) {
                yield this.store.delete().item(this).run();
            }
            else {
                throw Error('The model\'s store field is null. Delete the item using datastore\'s methods.');
            }
        });
    }
}
__decorate([
    class_transformer_1.Exclude({ toPlainOnly: true }),
    __metadata("design:type", datastore_1.Datastore)
], Model.prototype, "store", void 0);
exports.Model = Model;
//# sourceMappingURL=model.js.map