declare type AllowedFlags<T> = ({
    [P in keyof T]: T[P] extends Function ? never : P;
})[keyof T];
export declare type IComparator<T> = (first: T, second: T) => number;
export declare enum SortDirection {
    Ascending = 1,
    Descending = -1
}
export interface ISortField<T> {
    sort: IComparator<T> | SortDirection;
    priority?: number;
}
export declare type ISort<T> = {
    [P in keyof Pick<T, AllowedFlags<T>>]?: ISortField<T[P]>;
};
export {};
