"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_test_config_1 = require("../../index.test.config");
describe('model should', () => {
    it('save when save() is called', () => __awaiter(this, void 0, void 0, function* () {
        const planet = yield index_test_config_1.testStore.create(new index_test_config_1.Planet('a', 0));
        yield planet.save();
        const id = planet.meta.id;
        let searchedPlanet = yield index_test_config_1.testStore.get().id(id).one();
        planet.name = 'b';
        yield planet.save();
        searchedPlanet = yield index_test_config_1.testStore.get().id(id).one();
        if (searchedPlanet == null)
            throw Error('searchedPlanet is null.');
        expect(searchedPlanet.name).toEqual('b');
    }));
    it('delete when delete() is called', () => __awaiter(this, void 0, void 0, function* () {
        const newPlanet = yield index_test_config_1.testStore.pushItem(new index_test_config_1.Planet('a', 0));
        const id = newPlanet.meta.id;
        yield newPlanet.delete();
        const searchedPlanet = yield index_test_config_1.testStore.get().id(id).one();
        expect(searchedPlanet).toEqual(null);
    }));
});
//# sourceMappingURL=model.methods.test.js.map